﻿using Microsoft.IdentityModel.Clients.ActiveDirectory;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.AuthenticationManagement
{
    public class AuthTokenCacheInfo
    {
        public string ApplicationId { get; set; }

        public string ApplicationKey { get; set; }

        public string AccessToken { get; set; }

        public string DisplayableId {get;set;}

        public DateTimeOffset ExpiresOn { get; set; }

        public string RefreshToken { get; set; }

        public string Resource { get; set; }

        public string TenantId { get; set; }

        public LoginType LoginType { get; set; }

        public AuthTokenCacheInfo()
        {
        }

        public AuthTokenCacheInfo(string resource, LoginType loginType, AuthenticationResult authResult)
        {
            AccessToken = authResult.AccessToken;
            DisplayableId = authResult.UserInfo == null ? null : authResult.UserInfo.DisplayableId;
            ExpiresOn = authResult.ExpiresOn;
            RefreshToken = authResult.RefreshToken;
            Resource = resource;
            TenantId = authResult.TenantId;
            LoginType = loginType;
        }

        public AuthTokenCacheInfo(string tenantId, string applicationId, string applicationKey, string resource, LoginType loginType, AuthenticationResult authResult)
            : this(resource, loginType, authResult)
        {
            ApplicationId = applicationId;
            ApplicationKey = applicationKey;
            TenantId = tenantId;

        }

        public string GetAuthorizationHeader()
        {
            return String.Format("Bearer {0}", AccessToken);
        }
    }
}
