﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.AuthenticationManagement
{
    /// <summary>
    /// Class for storing token cache in memory
    /// </summary>
    public class AuthTokenStorage
    {
        private AuthTokenCache cache;
        private AuthTokenCacheInfo recentToken;

        public AuthTokenCache GetCache()
        {
            return this.cache ?? new AuthTokenCache();
        }

        public void SaveCache(AuthTokenCache cache)
        {
            this.cache = cache;
        }

        public AuthTokenCacheInfo GetRecentToken()
        {
            return this.recentToken;
        }

        public void SaveRecentToken(AuthTokenCacheInfo cacheInfo)
        {
            this.recentToken = cacheInfo;
        }

        public bool IsCacheValid()
        {
            return this.cache != null && this.cache.Count > 0;
        }

        public void ClearCache()
        {
            if (this.cache != null)
                this.cache.Clear();
        }
    }
}
