﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.AuthenticationManagement
{
    public interface IAuthManager
    {
        Task AcquireTokens(string clientId, string tenantId, string resource);
        Task<AuthTokenCacheInfo> GetToken(string clientId, string tenantId, string resource);
        AuthTokenCacheInfo GetTokenBySpn(string tenantId, string appId, string appKey, string resource);
        AuthTokenCacheInfo GetTokenByUpn(string clientId, string username, string password, string resource);
        bool IsCacheValid();
        void ClearTokenCache();
        IEnumerable<string> DumpTokenCache(string resource);
    }
}
