﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.Azure.DataModel.Authorization
{
    public class RoleAssignment
    {
        [JsonProperty("id")]
        public string Id { get; set; }
        [JsonProperty("name")]
        public string name { get; set; }
        [JsonProperty("properties")]
        public RoleAssignmentPropertiesWithScope Properties { get; set; }
        [JsonProperty("type")]
        public string Type { get; set; }
    }

    public class RoleAssignmentPropertiesWithScope
    {
        [JsonProperty("principalId")]
        public string PrincipalId { get; set; }
        [JsonProperty("roleDefinitionId")]
        public string RoleDefinitionId { get; set; }
        [JsonProperty("scope")]
        public string Scope { get; set; }
    }

    public class RoleAssignmentProperties
    {
        [JsonProperty("principalId")]
        public string PrincipalId { get; set; }
        [JsonProperty("roleDefinitionId")]
        public string RoleDefinitionId { get; set; }
    }

    public class CreateRoleAssignmentParameters
    {
        [JsonProperty("properties")]
        public RoleAssignmentProperties Properties { get; set; }
    }

    public class RoleAssignmentList
    {
        [JsonProperty("value")]
        public RoleAssignment[] RoleAssignments { get; set; }
    }
}
