﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.Azure.DataModel.Authorization
{
    public class RoleDefinitionList
    {
        [JsonProperty("value")]
        public RoleDefinition[] Permissions { get; set; }
    }

    public class RoleDefinition
    {
        [JsonProperty("id")]
        public string Id { get; set; }
        [JsonProperty("name")]
        public string Name { get; set; }
        [JsonProperty("properties")]
        public RoleDefinitionProperties Properties { get; set; }
        [JsonProperty("type")]
        public string Type { get; set; }
    }

    public class RoleDefinitionProperties
    {
        [JsonProperty("assignableScopes")]
        public string[] AssignableScopes { get; set; }
        [JsonProperty("description")]
        public string Description { get; set; }
        [JsonProperty("permissions")]
        public Permission[] Permissions { get; set; }
        [JsonProperty("roleName")]
        public string RoleName { get; set; }

        [JsonProperty("type")]
        public string Type { get; set; }
    }

    public class Permission
    {
        [JsonProperty("actions")]
        public string[] Actions { get; set; }
        [JsonProperty("notActions")]
        public string[] NotActions { get; set; }
    }

    public class PermissionList
    {
        [JsonProperty("value")]
        public Permission[] Permissions { get; set; }
    }
}
