﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.Azure.DataModel.Compute
{
    public class AvailabilitySetList
    {
        [JsonProperty("value")]
        public AvailabilitySet[] AvailabilitySets { get; set; }
    }

    public class AvailabilitySet
    {
        [JsonProperty("id")]
        public string Id { get; set; }
        [JsonProperty("name")]
        public string Name { get; set; }
        [JsonProperty("type")]
        public string Type { get; set; }
        [JsonProperty("location")]
        public string Location { get; set; }
        [JsonProperty("tags")]
        public IDictionary<string, string> Tags { get; set; }
        [JsonProperty("properties")]
        public AvailabilitySetProperties Properties { get; set; }
    }

    public class AvailabilitySetProperties
    {
        [JsonProperty("platformFaultdomainCount")]
        public int? PlatformFaultDomainCount { get; set; }
        [JsonProperty("platformUpdatedomainCount")]
        public int? PlatformUpdateDomainCount { get; set; }
        [JsonProperty("statuses")]
        public InstanceViewStatus[] Statuses { get; set; }
        [JsonProperty("virtualMachines")]
        public VirtualMachineReference[] VirtualMachines { get; set; }
    }

    public class InstanceViewStatus
    {
        [JsonProperty("code")]
        public string Code { get; set; }
        [JsonProperty("displayStatus")]
        public string DisplayStatus { get; set; }
        [JsonProperty("level")]
        public string Level { get; set; }
        [JsonProperty("message")]
        public string Message { get; set; }
        [JsonProperty("time")]
        public DateTimeOffset? Time { get; set; }
    }

    public class VirtualMachineReference
    {
        [JsonProperty("referenceUri")]
        public string Referenceuri { get; set; }
    }
}
