﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.Azure.DataModel.Compute
{
    public class OperationStatus
    {
        [JsonProperty("operationId")]
        public string OperationId { get; set; }
        [JsonProperty("status")]
        public string Status { get; set; }
        [JsonProperty("startTime")]
        public DateTime StartTime { get; set; }
        [JsonProperty("endTime")]
        public DateTime EndTime { get; set; }
        [JsonProperty("properties")]
        public OperationStatusProperties Properties { get; set; }
        [JsonProperty("error")]
        public OperationStatusError Error { get; set; }
    }

    public class OperationStatusProperties
    {
        [JsonProperty("output")]
        public string Output { get; set; }
    }

    public class OperationStatusError
    {
        [JsonProperty("details")]
        public OperationStatusErrorDetail[] Details { get; set; }
        [JsonProperty("innererror")]
        public InnerError InnerError { get; set; }
        [JsonProperty("code")]
        public string Code { get; set; }
        [JsonProperty("target")]
        public string Target { get; set; }
        [JsonProperty("message")]
        public string Message { get; set; }
    }

    public class OperationStatusErrorDetail
    {
        [JsonProperty("code")]
        public string Code { get; set; }
        [JsonProperty("target")]
        public string Target { get; set; }
        [JsonProperty("message")]
        public string Message { get; set; }
    }

    public class InnerError
    {
        [JsonProperty("exceptiontype")]
        public string ExceptionType { get; set; }
        [JsonProperty("errordetail")]
        public string ErrorDetail { get; set; }
    }
}
