﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.Azure.DataModel.Compute
{
    public class VirtualMachineExtension
    {
        [JsonProperty("id")]
        public string Id { get; set; }
        [JsonProperty("name")]
        public string Name { get; set; }
        [JsonProperty("type")]
        public string Type { get; set; }
        [JsonProperty("location")]
        public string Location { get; set; }
        [JsonProperty("tags")]
        public IDictionary<string, string> Tags { get; set; }
        [JsonProperty("properties")]
        public VirtualMachineExtensionProperties Properties { get; set; }
    }

    public class VirtualMachineExtensionProperties
    {
        [JsonProperty("publisher")]
        public string Publisher { get; set; }
        [JsonProperty("type")]
        public string ExtensionType { get; set; }
        [JsonProperty("instanceView")]
        public VirtualMachineExtensionInstanceView InstanceView { get; set; }
        [JsonProperty("protectedSettings")]
        public string ProtectedSettings { get; set; }
        [JsonProperty("settings")]
        public string Settings { get; set; }
        [JsonProperty("typeHandlerVersion")]
        public string TypeHandlerVersion { get; set; }
        [JsonProperty("autoUpgradeMinorVersion")]
        public string AutoUpgradeMinorVersion { get; set; }
    }

    public class VirtualMachineExtensionInstanceView
    {
        [JsonProperty("name")]
        public string Name { get; set; }
        [JsonProperty("type")]
        public string ExtensionType { get; set; }
        [JsonProperty("typeHandlerVersion")]
        public string TypeHandlerVersion { get; set; }
        [JsonProperty("substatuses")]
        public InstanceViewStatus[] Substatuses { get; set; }
        [JsonProperty("statuses")]
        public InstanceViewStatus[] Statuses { get; set; }
    }
    
}
