﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.Azure.DataModel.Compute
{
    public class VirtualMachineImageResource
    {
        [JsonProperty("id")]
        public string Id { get; set; }
        [JsonProperty("name")]
        public string Name { get; set; }
        [JsonProperty("location")]
        public string Location { get; set; }
    }

    public class PurchasePlan
    {
        [JsonProperty("name")]
        public string Name { get; set; }
        [JsonProperty("product")]
        public string Product { get; set; }
        [JsonProperty("publisher")]
        public string Publisher { get; set; }
    }

    public class VirtualMachineImage
    {
        [JsonProperty("id")]
        public string Id { get; set; }
        [JsonProperty("name")]
        public string Name { get; set; }
        [JsonProperty("location")]
        public string Location { get; set; }
        [JsonProperty("properties")]
        public VirtualMachineImageProperties Properties { get; set; }
    }

    public class VirtualMachineImageProperties
    {
        [JsonProperty("plan")]
        public PurchasePlan PurchasePlan { get; set; } 
        [JsonProperty("dataDiskImages")]
        public DataDiskImage[] DataDiskImages { get; set; }
        [JsonProperty("osDiskImage")]
        public OSdiskImage OSDiskImage { get; set; }
    }

    public class DataDiskImage
    {
        [JsonProperty("lun")]
        public int Lun { get; set; }
    }

    public class OSdiskImage
    {
        [JsonProperty("operatingSystem")]
        public string OperatingSystem { get; set; }
    }
}
