﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.Azure.DataModel.Network
{
    public class NetworkInterfaceList
    {
        [JsonProperty("value")]
        public NetworkInterface[] NetworkInterfaces { get; set; }
        [JsonProperty("nextLink")]
        public string NextLink { get; set; }
    }

    public class NetworkInterface
    {
        [JsonProperty("id")]
        public string Id { get; set; }
        [JsonProperty("name")]
        public string Name { get; set; }
        [JsonProperty("type")]
        public string Type { get; set; }
        [JsonProperty("location")]
        public string Location { get; set; }
        [JsonProperty("tags")]
        public IDictionary<string,string> Tags { get; set; }
        [JsonProperty("etag")]
        public string Etag { get; set; }
        [JsonProperty("properties")]
        public NetworkInterfaceProperties Properties { get; set; }
    }

    public class NetworkInterfaceProperties
    {
        [JsonProperty("dnsSettings")]
        public NetworkInterfaceDnsSettings DnsSettings { get; set; }
        [JsonProperty("enableIPForwarding")]
        public bool EnableIPForwarding { get; set; }
        [JsonProperty("ipConfigurations")]
        public NetworkInterfaceIpConfiguration[] IpConfigurations { get; set; }
        [JsonProperty("macAddress")]
        public string MacAddress { get; set; }
        [JsonProperty("networkSecurityGroup")]
        public ResourceId NetworkSecurityGroup { get; set; }
        [JsonProperty("primary")]
        public bool? Primary { get; set; }
        [JsonProperty("provisioningState")]
        public string ProvisioningState { get; set; }
        [JsonProperty("virtualMachine")]
        public ResourceId VirtualMachine { get; set; }
    }

    public class NetworkInterfaceIpConfiguration
    {
        [JsonProperty("id")]
        public string Id { get; set; }
        [JsonProperty("etag")]
        public string Etag { get; set; }
        [JsonProperty("name")]
        public string Name { get; set; }
        [JsonProperty("properties")]
        public NetworkInterfaceIpConfigurationProperties Properties { get; set; }
    }

    public class NetworkInterfaceIpConfigurationProperties
    {
        [JsonProperty("loadBalancerbackendAddressPools")]
        public ResourceId[] LoadBalancerbackendAddressPools { get; set; }
        [JsonProperty("loadBalancerInboundNatRules")]
        public ResourceId[] LoadBalancerInboundNatRules { get; set; }
        [JsonProperty("privateIpAddress")]
        public string PrivateIpAddress { get; set; }
        [JsonProperty("privateIpAllocationMethod")]
        public string PrivateIpAllocationMethod { get; set; }
        [JsonProperty("provisioningState")]
        public string ProvisioningState { get; set; }
        [JsonProperty("publicIpAddress")]
        public ResourceId PublicIpAddress { get; set; }
        [JsonProperty("subnet")]
        public ResourceId Subnet { get; set; }
    }

    public class NetworkInterfaceDnsSettings
    {
        [JsonProperty("appliedDnsServers")]
        public string[] AppliedDnsServers { get; set; }
        [JsonProperty("dnsServers")]
        public string[] DnsServers { get; set; }
        [JsonProperty("internalDnsNameLabel")]
        public string InternalDnsNamelabel { get; set; }
        [JsonProperty("internalFqdn")]
        public string InternalFqdn { get; set; }
    }

    public class ResourceId
    {
        [JsonProperty("id")]
        public string Id { get; set; }
    }
}
