﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.Azure.DataModel.Network
{
    public class NetworkSecurityGroupList
    {
        [JsonProperty("value")]
        public NetworkSecurityGroup[] NetworkSecurityGroups { get; set; }
        [JsonProperty("nextLink")]
        public string NextLink { get; set; }
    }

    public class NetworkSecurityGroup
    {
        [JsonProperty("id")]
        public string Id { get; set; }
        [JsonProperty("name")]
        public string Name { get; set; }
        [JsonProperty("type")]
        public string Type { get; set; }
        [JsonProperty("location")]
        public string Location { get; set; }
        [JsonProperty("tags")]
        public IDictionary<string, string> Tags { get; set; }
        [JsonProperty("etag")]
        public string Etag { get; set; }
        [JsonProperty("properties")]
        public NetworkSecurityGroupProperties Properties { get; set; }
    }

    public class NetworkSecurityGroupProperties
    {
        [JsonProperty("defaultSecurityRules")]
        public SecurityRule[] DefaultSecurityRules { get; set; }
        [JsonProperty("networkInterfaces")]
        public ResourceId[] NetworkInterfaces { get; set; }
        [JsonProperty("provisioningState")]
        public string ProvisioningState { get; set; }
        [JsonProperty("securityRules")]
        public SecurityRule[] SecurityRules { get; set; }
        [JsonProperty("subnets")]
        public ResourceId[] Subnets { get; set; }
    }

    public class SecurityRuleList
    {
        [JsonProperty("value")]
        public SecurityRule[] SecurityRules { get; set; }
        [JsonProperty("nextLink")]
        public string NextLink { get; set; }
    }

    public class SecurityRule
    {
        [JsonProperty("id")]
        public string Id { get; set; }
        [JsonProperty("etag")]
        public string Etag { get; set; }
        [JsonProperty("name")]
        public string Name { get; set; }
        [JsonProperty("properties")]
        public SecurityRuleProperties Properties { get; set; }
    }

    public class SecurityRuleProperties
    {
        [JsonProperty("access")]
        public string Access { get; set; }
        [JsonProperty("description")]
        public string Description { get; set; }
        [JsonProperty("destinationAddressPrefix")]
        public string DestinationAddressPrefix { get; set; }
        [JsonProperty("destinationPortRange")]
        public string DestinationPortRange { get; set; }
        [JsonProperty("direction")]
        public string Direction { get; set; }
        [JsonProperty("priority")]
        public int Priority { get; set; }
        [JsonProperty("protocol")]
        public string Protocol { get; set; }
        [JsonProperty("provisioningState")]
        public string ProvisioningState { get; set; }
    }
}
