﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.Azure.DataModel.Network
{
    public class PublicIpAddressList
    {
        [JsonProperty("value")]
        public PublicIpAddress[] PublicIpAddresses { get; set; }
        [JsonProperty("nextLink")]
        public string NextLink { get; set; }
    }

    public class PublicIpAddress
    {
        [JsonProperty("id")]
        public string Id { get; set; }
        [JsonProperty("name")]
        public string Name { get; set; }
        [JsonProperty("type")]
        public string Type { get; set; }
        [JsonProperty("location")]
        public string Location { get; set; }
        [JsonProperty("tags")]
        public IDictionary<string, string> Tags { get; set; }
        [JsonProperty("etag")]
        public string Etag { get; set; }
        [JsonProperty("properties")]
        public PublicIpAddressProperties Properties { get; set; }
    }

    public class PublicIpAddressProperties
    {
        [JsonProperty("dnsSettings")]
        public PublicIpAddressDnsSettings DnsSettings { get; set; }
        [JsonProperty("idleTimeoutInMinutes")]
        public int? IdleTimeoutInMinutes { get; set; }
        [JsonProperty("ipAddress")]
        public string IpAddress { get; set; }
        [JsonProperty("ipconfiguration")]
        public ResourceId IpConfiguration { get; set; }
        [JsonProperty("provisioningState")]
        public string ProvisioningState { get; set; }
        [JsonProperty("publicIpAllocationMethod")]
        public string PublicIpAllocationMethod { get; set; }
    }

    public class PublicIpAddressDnsSettings
    {
        [JsonProperty("domainNameLabel")]
        public string DomainNameLabel { get; set; }
        [JsonProperty("fqdn")]
        public string Fqdn { get; set; }
        [JsonProperty("reverseFqdn")]
        public string ReverseFqdn { get; set; }
    }
}
