﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.Azure.DataModel.Network
{
    public class RouteTable
    {
        [JsonProperty("id")]
        public string Id { get; set; }
        [JsonProperty("name")]
        public string Name { get; set; }
        [JsonProperty("type")]
        public string Type { get; set; }
        [JsonProperty("location")]
        public string Location { get; set; }
        [JsonProperty("tags")]
        public IDictionary<string, string> Tags { get; set; }
        [JsonProperty("etag")]
        public string Etag { get; set; }
        [JsonProperty("properties")]
        public RouteTableProperties Properties { get; set; }
    }

    public class RouteTableProperties
    {
        [JsonProperty("provisioningState")]
        public string ProvisioningState { get; set; }
        [JsonProperty("routes")]
        public Route[] Routes { get; set; }
        [JsonProperty("subnets")]
        public ResourceId[] Subnets { get; set; }
    }

    public class RouteTableList
    {
        [JsonProperty("value")]
        public RouteTable[] RouteTables { get; set; }
        [JsonProperty("nextLink")]
        public string NextLink { get; set; }
    }

    public class RouteList
    {
        [JsonProperty("value")]
        public Route[] Routes { get; set; }
        [JsonProperty("nextLink")]
        public string NextLink { get; set; }
    }

    public class Route
    {
        [JsonProperty("id")]
        public string Id { get; set; }
        [JsonProperty("etag")]
        public string Etag { get; set; }
        [JsonProperty("name")]
        public string Name { get; set; }
        [JsonProperty("properties")]
        public RouteProperties Properties { get; set; }
    }

    public class RouteProperties
    {
        [JsonProperty("addressPrefix")]
        public string AddressPrefix { get; set; }
        [JsonProperty("nextHopIpAddress")]
        public string NextHopIpAddress { get; set; }
        [JsonProperty("nextHopType")]
        public string NextHopType { get; set; }
        [JsonProperty("provisioningState")]
        public string ProvisioningState { get; set; }
    }
}
