﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.Azure.DataModel.Network
{
    public class VirtualNetworkList
    {
        [JsonProperty("value")]
        public VirtualNetwork[] VirtualNetworks { get; set; }
        [JsonProperty("nextLink")]
        public string NextLink { get; set; }
    }

    public class VirtualNetwork
    {
        [JsonProperty("id")]
        public string Id { get; set; }
        [JsonProperty("name")]
        public string Name { get; set; }
        [JsonProperty("type")]
        public string Type { get; set; }
        [JsonProperty("location")]
        public string Location { get; set; }
        [JsonProperty("tags")]
        public IDictionary<string, string> Tags { get; set; }
        [JsonProperty("etag")]
        public string Etag { get; set; }
        [JsonProperty("properties")]
        public VirtualNetworkProperties Properties { get; set; }
    }

    public class VirtualNetworkProperties
    {
        [JsonProperty("addressSpace")]
        public AddressSpace AddressSpace { get; set; }
        [JsonProperty("dnsOptions")]
        public DnsOptions DnsOptions { get; set; }
        [JsonProperty("provisioningState")]
        public string ProvisioningState { get; set; }
        [JsonProperty("subnets")]
        public Subnet[] Subnets { get; set; }
    }

    public class DnsOptions
    {
        [JsonProperty("dnsServers")]
        public string[] DnsServers { get; set; }
    }
    public class SubnetList
    {
        [JsonProperty("value")]
        public Subnet[] Subnets { get; set; }
        [JsonProperty("nextLink")]
        public string NextLink { get; set; }
    }
    public class Subnet
    {
        [JsonProperty("id")]
        public string Id { get; set; }
        [JsonProperty("etag")]
        public string Etag { get; set; }
        [JsonProperty("name")]
        public string Name { get; set; }
        [JsonProperty("properties")]
        public SubnetProperties Properties { get; set; }
    }

    public class SubnetProperties
    {
        [JsonProperty("addressPrefix")]
        public string AddressPrefix { get; set; }
        [JsonProperty("ipConfigurations")]
        public ResourceId[] IpConfigurations { get; set; }
        [JsonProperty("networkSecurityGroup")]
        public ResourceId NetworksecurityGroup { get; set; }
        [JsonProperty("provisioningState")]
        public string ProvisioningState { get; set; }
        [JsonProperty("routeTable")]
        public ResourceId RouteTable { get; set; }
    }
}
