﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.Azure.DataModel.ResourceManager
{
    public class ProviderList
    {
        [JsonProperty("value")]
        public Provider[] Providers { get; set; }
        [JsonProperty("nextLink")]
        public string NextLink { get; set; }
    }

    public class Provider
    {
        [JsonProperty("id")]
        public string Id { get; set; }
        [JsonProperty("namespace")]
        public string Namespace { get; set; }
        [JsonProperty("authorization")]
        public Authorization Authorization { get; set; }
        [JsonProperty("resourceTypes")]
        public ProviderResourceType[] ResourceTypes { get; set; }
        [JsonProperty("registrationState")]
        public string RegistrationState { get; set; }
    }

    public class Authorization
    {
        [JsonProperty("applicationId")]
        public string ApplicationId { get; set; }
        [JsonProperty("roleDefinitionId")]
        public string RoleDefinitionId { get; set; }
    }
    public class ProviderResourceType
    {
        [JsonProperty("resourceType")]
        public string ResourceType { get; set; }
        [JsonProperty("locations")]
        public string[] Locations { get; set; }
        [JsonProperty("apiVersions")]
        public string[] ApiVersions { get; set; }
        [JsonProperty("properties")]
        public IDictionary<string, string> Properties { get; set; }
    }
}
