﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.Azure.DataModel.ResourceManager
{
    public class ResourceList
    {
        [JsonProperty("value")]
        public Resource[] Resources { get; set; } 
        [JsonProperty("nextLink")]
        public string NextLink { get; set; }
    }

    public class Resource
    {
        [JsonProperty("id")]
        public string Id { get; set; }
        [JsonProperty("name")]
        public string Name { get; set; }
        [JsonProperty("type")]
        public string Type { get; set; }
        [JsonProperty("location")]
        public string Location { get; set; }
        [JsonProperty("tags")]
        public IDictionary<string, string> Tags { get; set; }
        [JsonProperty("plan")]
        public Plan Plan { get; set; }
        [JsonProperty("properties")]
        public ResourceProperties Properties { get; set; }
    }

    public class ResourceProperties
    {
        [JsonProperty("provisioningState")]
        public string ProvisioningState { get; set; }
    }

    public class Plan
    {
        [JsonProperty("name")]
        public string Name { get; set; }
        [JsonProperty("product")]
        public string Product { get; set; }
        [JsonProperty("promotionCode")]
        public string PromotionCode { get; set; }
        [JsonProperty("publisher")]
        public string Publisher { get; set; }
    }
}
