﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.Azure.DataModel.ResourceManager
{
    public class ResourceGroup
    {
        [JsonProperty("id")]
        public string Id { get; set; }

        [JsonProperty("name")]
        public string Name { get; set; }

        [JsonProperty("location")]
        public string Location { get; set; }

        [JsonProperty("properties")]
        public ResourceGroupProperties Properties { get; set; }

        [JsonProperty("tags")]
        public IDictionary<string,string> Tags { get; set; }
    }

    public class CreateResourceGroupParameters
    {
        [JsonProperty("location")]
        public string Location { get; set; }

        [JsonProperty("tags")]
        public IDictionary<string, string> Tags { get; set; }
    }

    public class ResourceGroupProperties
    {
        [JsonProperty("provisioningState")]
        public string ProvisioningState { get; set; }
    }

    public class ResourceGroupList
    {
        [JsonProperty("value")]
        public ResourceGroup [] ResourceGroups { get; set; }
        [JsonProperty("nextLink")]
        public string NextLink { get; set; }
    }
    

}
