﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.Azure.DataModel.SQLDatabase
{
    public class Database
    {
        [JsonProperty("id")]
        public string Id { get; set; }
        [JsonProperty("name")]
        public string Name { get; set; }
        [JsonProperty("type")]
        public string Type { get; set; }
        [JsonProperty("location")]
        public string Location { get; set; }
        [JsonProperty("tags")]
        public IDictionary<string,string> Tags { get; set; }
        [JsonProperty("properties")]
        public DatabaseProperties Properties { get; set; }
    }

    public class DatabaseProperties
    {
        [JsonProperty("databaseId")]
        public string DatabaseId { get; set; }
        [JsonProperty("edition")]
        public string Edition { get; set; }
        [JsonProperty("elasticPoolId")]
        public string ElasticPoolId { get; set; }
        [JsonProperty("elasticPoolUri")]
        public string ElasticPoolUri { get; set; }
        [JsonProperty("elasticPoolName")]
        public string ElasticPoolName { get; set; }
        [JsonProperty("serviceObjective")]
        public string ServiceObjective { get; set; }
        [JsonProperty("collation")]
        public string Collation { get; set; }
        [JsonProperty("maxSizeBytes")]
        public long MaxSizeBytes { get; set; }
        [JsonProperty("creationDate")]
        public DateTime CreationDate { get; set; }
        [JsonProperty("currentServiceObjectiveId")]
        public string CurrentServiceObjectiveId { get; set; }
        [JsonProperty("requestedServiceObjectiveId")]
        public string RequestedServiceobjectiveId { get; set; }
        [JsonProperty("earliestRestoreDate")]
        public DateTime? EarliestRestoreDate { get; set; }
        [JsonProperty("defaultSecondaryLocation")]
        public string DefaultSecondaryLocation { get; set; }
    }

    public class DatabaseList
    {
        [JsonProperty("value")]
        public Database[] Databases { get; set; }
    }

    public class DatabaseCreateUpdateProperties
    {
        [JsonProperty("collation")]
        public string Collation { get; set; }
        [JsonProperty("createMode")]
        public string CreateMode { get; set; }
        [JsonProperty("edition")]
        public string Edition { get; set; }
        [JsonProperty("elasticPoolName")]
        public string ElasticPoolName { get; set; }
        [JsonProperty("maxSizeBytes")]
        public long? MaxSizeBytes { get; set; }
        [JsonProperty("requestedServiceObjectiveId")]
        public string RequestedServiceObjectiveId { get; set; }
        [JsonProperty("requestedServiceObjectiveName")]
        public string RequestedServiceObjectiveName { get; set; }
        [JsonProperty("sourceDatabaseId")]
        public string SourceDatabaseId { get; set; }
    }

    public class DatabaseCreateUpdateParameters
    {
        [JsonProperty("location")]
        public string Location { get; set; }
        [JsonProperty("tags")]
        public IDictionary<string,string> Tags { get; set; }
        [JsonProperty("properties")]
        public DatabaseCreateUpdateProperties Properties { get; set; }
    }
}
