﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.Azure.DataModel.SQLDatabase
{
    public class ElasticPool
    {
        [JsonProperty("id")]
        public string Id { get; set; }
        [JsonProperty("name")]
        public string Name { get; set; }
        [JsonProperty("type")]
        public string Type { get; set; }
        [JsonProperty("location")]
        public string Location { get; set; }
        [JsonProperty("tags")]
        public IDictionary<string, string> Tags { get; set; }
        [JsonProperty("properties")]
        public ElasticPoolProperties Properties { get; set; }
    }

    public class ElasticPoolProperties
    {
        [JsonProperty("creationDate")]
        public DateTime? CreationDate { get; set; }
        [JsonProperty("databaseDtuMax")]
        public long DatabaseDtuMax { get; set; }
        [JsonProperty("databaseDtuMin")]
        public long DatabaseDtuMin { get; set; }
        [JsonProperty("dtu")]
        public long Dtu { get; set; }
        [JsonProperty("edition")]
        public string Edition { get; set; }
        [JsonProperty("state")]
        public string State { get; set; }
        [JsonProperty("storageMB")]
        public long StorageMB { get; set; }
    }

    public class ElasticPoolList
    {
        [JsonProperty("value")]
        public ElasticPool[] ElasticPools { get; set; }
    }

    public class ElasticPoolCreateUpdateParameters
    {
        [JsonProperty("location")]
        public string Location { get; set; }
        [JsonProperty("tags")]
        public IDictionary<string, string> Tags { get; set; }
        [JsonProperty("properties")]
        public ElasticPoolCreateUpdateProperties Properties { get; set; }
    }

    public class ElasticPoolCreateUpdateProperties
    {
        [JsonProperty("databaseDtuMax")]
        public long? DatabaseDtuMax { get; set; }
        [JsonProperty("databaseDtuMin")]
        public long? DatabaseDtuMin { get; set; }
        [JsonProperty("dtu")]
        public long? Dtu { get; set; }
        [JsonProperty("edition")]
        public string Edition { get; set; }
        [JsonProperty("storageMB")]
        public long? StorageMB { get; set; }
    }
}
