﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.Azure.DataModel.SQLDatabase
{
    public class Server
    {
        [JsonProperty("id")]
        public string Id { get; set; }
        [JsonProperty("name")]
        public string Name { get; set; }
        [JsonProperty("type")]
        public string Type { get; set; }
        [JsonProperty("location")]
        public string Location { get; set; }
        [JsonProperty("tags")]
        public IDictionary<string, string> Tags { get; set; }
        [JsonProperty("properties")]
        public ServerProperties Properties { get; set; }
    }

    public class ServerProperties
    {
        [JsonProperty("administratorLogin")]
        public string AdministratorLogin { get; set; }
        [JsonProperty("administratorLoginPassword")]
        public string AdministratorLoginPassword { get; set; }
        [JsonProperty("fullyQualifiedDomainName")]
        public string FullyQualifiedDomainName { get; set; }
        [JsonProperty("version")]
        public string Version { get; set; }
    }

    public class ServerCreateUpdateProperties
    {
        [JsonProperty("administratorLogin")]
        public string AdministratorLogin { get; set; }
        [JsonProperty("administratorLoginPassword")]
        public string AdministratorLoginPassword { get; set; }
        [JsonProperty("version")]
        public string Version { get; set; }
    }

    public class ServerCreateUpdateParameters
    {
        [JsonProperty("location")]
        public string Location { get; set; }
        [JsonProperty("tags")]
        public IDictionary<string, string> Tags { get; set; }
        [JsonProperty("properties")]
        public ServerCreateUpdateProperties Properties { get; set; }
    }

    public class ServerList
    {
        [JsonProperty("value")]
        public Server[] Servers { get; set; }
    }
}
