﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.Azure.DataModel.SQLDatabase
{
    public class ServiceObjective
    {
        [JsonProperty("id")]
        public string Id { get; set; }
        [JsonProperty("name")]
        public string Name { get; set; }
        [JsonProperty("type")]
        public string Type { get; set; }
        [JsonProperty("location")]
        public string Location { get; set; }
        [JsonProperty("tags")]
        public IDictionary<string, string> Tags { get; set; }
        [JsonProperty("properties")]
        public ServiceObjectiveProperties Properties { get; set; }
    }

    public class ServiceObjectiveProperties
    {
        [JsonProperty("description")]
        public string Description { get; set; }
        [JsonProperty("enabled")]
        public bool Enabled { get; set; }
        [JsonProperty("isDefault")]
        public bool IsDefault { get; set; }
        [JsonProperty("isSystem")]
        public bool IsSystem { get; set; }
        [JsonProperty("serviceObjectiveName")]
        public string ServiceObjectiveName { get; set; }
    }

    public class ServiceObjectiveList
    {
        [JsonProperty("value")]
        public ServiceObjective[] ServiceObjectives { get; set; }
    }
}
