﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.Azure.DataModel.Storage
{
    public class StorageAccount
    {
        [JsonProperty("id")]
        public string Id { get; set; }
        [JsonProperty("name")]
        public string Name { get; set; }
        [JsonProperty("type")]
        public string Type { get; set; }
        [JsonProperty("location")]
        public string Location { get; set; }
        [JsonProperty("tags")]
        public IDictionary<string, string> Tags { get; set; }
        [JsonProperty("properties")]
        public StorageAccountProperties Properties { get; set; }
    }

    public class StorageAccountProperties
    {
        [JsonProperty("accountType")]
        public string AccountType { get; set; }
        [JsonProperty("creationTime")]
        public DateTime? CreationTime { get; set; }
        [JsonProperty("customDomain")]
        public CustomDomain CustomDomain { get; set; }
        [JsonProperty("lastGeoFailoverTime")]
        public DateTime? LastGeoFailoverTime { get; set; }
        [JsonProperty("primaryEndpoints")]
        public Endpoints PrimaryEndpoints { get; set; }
        [JsonProperty("primaryLocation")]
        public string PrimaryLocation { get; set; }
        [JsonProperty("provisioningState")]
        public string ProvisioningState { get; set; }
        [JsonProperty("secondaryEndpoints")]
        public Endpoints SecondaryEndpoints { get; set; }
        [JsonProperty("secondaryLocation")]
        public string SecondaryLocation { get; set; }
        [JsonProperty("statusOfPrimary")]
        public string StatusOfPrimary { get; set; }
        [JsonProperty("statusOfSecondary")]
        public string StatusOfSecondary { get; set; }
    }

    public class CreateStorageAccountParameters
    {
        [JsonProperty("accountType")]
        public string AccountType { get; set; }
        [JsonProperty("location")]
        public string Location { get; set; }
        [JsonProperty("tags")]
        public IDictionary<string, string> Tags { get; set; }
    }

    public class CustomDomain
    {
        [JsonProperty("name")]
        public string Name { get; set; }
        [JsonProperty("usSubDomain")]
        public bool? UseSubDomain { get; set; }
    }

    public class Endpoints
    {
        [JsonProperty("blob")]
        public string Blob { get; set; }
        [JsonProperty("queue")]
        public string Queue { get; set; }
        [JsonProperty("table")]
        public string Table { get; set; }
    }

    public class StorageAccountList
    {
        [JsonProperty("value")]
        public StorageAccount[] SotrageAccounts { get; set; }
        [JsonProperty("nextLink")]
        public string NextLink { get; set; }
    }

    public class StorageAccountKeys
    {
        [JsonProperty("key1")]
        public string Key1 { get; set; }
        [JsonProperty("key2")]
        public string Key2 { get; set; }
    }

    
}
