﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.AzureActiveDirectory.DataModel
{
    public class Applications
    {
        [JsonProperty("odata.emtadata")]
        public string Metadata { get; set; }
        [JsonProperty("value")]
        public Application[] ApplicationList { get; set; }
    }

    public class Application
    {
        [JsonProperty("appId")]
        public string AppId { get; set; }

        [JsonProperty("appRoles")]
        public AppRole[] AppRoles { get; set; }

        [JsonProperty("availbleToOtherTenants")]
        public bool AvailableToOtherTenant { get; set; }

        [JsonProperty("displayName")]
        public string DisplayName { get; set; }
    }

    public class AppRole
    {
        [JsonProperty("allowedMemberTypes")]
        public string[] AllowedMemberTypes { get; set;}

        [JsonProperty("description")]
        public string Description { get; set; }

        [JsonProperty("displaName")]
        public string DisplayName { get; set; }

        [JsonProperty("id")]
        public string Id { get; set; }

        [JsonProperty("isEnabled")]
        public bool IsEnabled { get; set; }
        
        [JsonProperty("value")]
        public string Value { get; set; }
    }

    public class AppRoleAssignment
    {
        [JsonProperty("creationTimestamp")]
        public DateTime CreationTimestamp { get; set; }

        [JsonProperty("id")]
        public string Id { get; set; }

        [JsonProperty("principalDisplayName")]
        public string PrincipalDisplayName { get; set; }

        [JsonProperty("principalId")]
        public string PrincipalId { get; set; }

        [JsonProperty("principalType")]
        public string PrincipalType { get; set; }

        [JsonProperty("resourceDisplayName")]
        public string ResourceDisplayName { get; set; }

        [JsonProperty("resourceId")]
        public string ResourceId { get; set; }
    }
}
