﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.AzureActiveDirectory.DataModel
{
    public class Groups
    {
        [JsonProperty("odata.emtadata")]
        public string Metadata { get; set; }
        [JsonProperty("value")]
        public Group[] GroupList { get; set; }
    }

    public class Group
    {
        [JsonProperty("description")]
        public string Description { get; set; }
        [JsonProperty("dirSyncEnabled")]
        public bool? DirSyncEnabled { get; set; }
        [JsonProperty("displayName")]
        public string DisplayName { get; set; }
        [JsonProperty("lastDirSyncTime")]
        public DateTime? lastDirSyncTime { get; set; }
        [JsonProperty("mail")]
        public string Mail { get; set; }
        [JsonProperty("mailEnabled")]
        public bool MailEnabled { get; set; }
        [JsonProperty("mailNickName")]
        public string MailNickName { get; set; }
        [JsonProperty("objectId")]
        public string ObjectId { get; set; }

        [JsonProperty("objectType")]
        public string ObjectType { get; set; }

        [JsonProperty("onPremisesSecurityIdentifier")]
        public string OnPremisesSecurityIdentifier { get; set; }

        [JsonProperty("provisioningErrors")]
        public ProvisioningError[] ProvisioningErrors { get; set; }

        [JsonProperty("proxyAddresses")]
        public string[] ProxyAddresses { get; set; }

        [JsonProperty("securityEnabled")]
        public bool SecurityEnabled { get; set; }
    }
}
