﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.AzureActiveDirectory.DataModel
{
    public class ServicePrincipals
    {
        [JsonProperty("odata.emtadata")]
        public string Metadata { get; set; }
        [JsonProperty("value")]
        public ServicePrincipal[] ServicePrincipalList { get; set; }
    }

    public class ServicePrincipal
    {
        [JsonProperty("accountEnabled")]
        public bool? AccountEnabled { get; set; }

        [JsonProperty("appDisplayName")]
        public string AppDisplayName { get; set; }

        [JsonProperty("appId")]
        public string AppId { get; set; }

        [JsonProperty("appOwnerTenantId")]
        public string AppOwnerTenantId { get; set; }

        [JsonProperty("appRoleAssignmentRequired")]
        public bool? AppRoleAssignmentRequired { get; set; }

        [JsonProperty("appRoles")]
        public AppRole[] AppRoles { get; set; }

        [JsonProperty("authenticationPolicy")]
        public ServicePrincipalAuthenticationPolicy AuthenticationPolicy { get; set; }

        [JsonProperty("displayName")]
        public string DisplayName { get; set; }

        [JsonProperty("errorUrl")]
        public string ErrorUrl { get; set; }

        [JsonProperty("homepage")]
        public string Homepage { get; set; }

        [JsonProperty("keyCredendtial")]
        public KeyCredential KeyCredential { get; set; }

        [JsonProperty("logoutUrl")]
        public string LogoutUrl { get; set; }

        [JsonProperty("oauth2Permissions")]
        public OAuth2Permission[] OAuth2Permissions { get; set; }

        [JsonProperty("objectId")]
        public string ObjectId { get; set; }

        [JsonProperty("objectType")]
        public string ObjectType { get; set; }

        [JsonProperty("passwordCredentials")]
        public PasswordCredential[] PasswordCredentials { get; set; }

        [JsonProperty("preferredTokenSigningKeyThumbprint")]
        public string PreferredTokenSigningKeyThumbprint { get; set; }

        [JsonProperty("publisherName")]
        public string PublisherName { get; set; }

        [JsonProperty("replyUrls")]
        public string[] ReplyUrls { get; set; }

        [JsonProperty("samMetadataUrl")]
        public string SamMetadataUrl { get; set; }

        [JsonProperty("servicePrinicpalName")]
        public string ServicePrincipalName { get; set; }

        [JsonProperty("tags")]
        public string[] Tags { get; set; }
    }
}
