﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.AzureActiveDirectory.DataModel
{
    public class TenantDetails
    {
        [JsonProperty("odata.emtadata")]
        public string Metadata { get; set; }
        [JsonProperty("value")]
        public TenantDetail[] TenantDetailList { get; set; }
    }

    public class TenantDetail
    {
        [JsonProperty("assignedPlans")]
        public AssignedPlan [] AssignedPlans { get; set; }

        [JsonProperty("city")]
        public string City { get; set; }

        [JsonProperty("companyLastDirSyncTime")]
        public DateTime? CompanylastDirSyncTime { get; set; }

        [JsonProperty("country")]
        public string Country { get; set; }

        [JsonProperty("countryLetterCode")]
        public string CountryLetterCode { get; set; }

        [JsonProperty("dirSyncEnabled")]
        public bool? DirSyncEnabled { get; set; }

        [JsonProperty("displayName")]
        public string DisplayName { get; set; }

        [JsonProperty("marketingNotificationEmails")]
        public string[] MarketingNotificationEmails { get; set; }

        [JsonProperty("objectId")]
        public string ObjectId { get; set; }

        [JsonProperty("objectType")]
        public string ObjectType { get; set; }

        [JsonProperty("postalCode")]
        public string PostalCode { get; set; }

        [JsonProperty("preferredLanguage")]
        public string PreferredLanguage { get; set; }

        [JsonProperty("provisionedPlans")]
        public ProvisionedPlan[] ProvisionedPlans { get; set; }

        [JsonProperty("provisioningErrors")]
        public ProvisioningError[] ProvisioningErrors { get; set; }

        [JsonProperty("state")]
        public string State { get; set; }

        [JsonProperty("street")]
        public string Street { get; set; }

        [JsonProperty("technicalNotificationMails")]
        public string [] TechnicalNotificationMails { get; set; }

        [JsonProperty("telephoneNumber")]
        public string TelephoneNumber { get; set; }

        [JsonProperty("tenantType")]
        public string TenantType { get; set; }

        [JsonProperty("verifiedDomains")]
        public VerifiedDomain[] VerifiedDomains { get; set; }
    }
}
