﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.AzureActiveDirectory.DataModel
{
    public class Users
    {
        [JsonProperty("odata.emtadata")]
        public string Metadata { get; set; }
        [JsonProperty("value")]
        public User[] UserList { get; set; }
    }

    public class User
    {
        [JsonProperty("odata.type")]
        public string Type { get; set; }

        [JsonProperty("objecttype")]
        public string ObjectType { get; set; }

        [JsonProperty("objectId")]
        public string ObjectId { get; set; }

        [JsonProperty("accountEnabled")]
        public bool AccountEnabled { get; set; }

        [JsonProperty("assignedLicenses")]
        public AssignedLicense[] AssignedLicenses { get; set; }

        [JsonProperty("assignedPlans")]
        public AssignedPlan[] AssignedPlans { get; set; }

        [JsonProperty("city")]
        public string City { get; set; }

        [JsonProperty("country")]
        public string Country { get; set; }

        [JsonProperty("department")]
        public string Department { get; set; }

        [JsonProperty("dirsyncEnabled")]
        public bool? DirSyncEnabled { get; set; }

        [JsonProperty("displayName")]
        public string DisplayName { get; set; }

        [JsonProperty("facsimileTelephoneNumber")]
        public string FacsimileTelephnoneNumber { get; set; }

        [JsonProperty("givenName")]
        public string GivenName { get; set; }

        [JsonProperty("immutableId")]
        public string ImmutableId { get; set; }

        [JsonProperty("jobTitle")]
        public string JobTitle { get; set; }

        [JsonProperty("lastDirSyncTime")]
        public DateTime? LastDirSyncTime { get; set; }

        [JsonProperty("mail")]
        public string Mail { get; set; }

        [JsonProperty("mailNickName")]
        public string MailNickName { get; set; }

        [JsonProperty("mobile")]
        public string Mobile { get; set; }

        [JsonProperty("onPremisesSecurityIdentifier")]
        public string OnPremisesSecurityHandler { get; set; }

        [JsonProperty("otherMails")]
        public string[] OtherMails { get; set; }

        [JsonProperty("passwordPolicies")]
        public string PasswordPolicies { get; set; }

        [JsonProperty("passwordProfile")]
        public PasswordProfile PasswordProfile { get; set; }

        [JsonProperty("phsicalDeliveryOfficeName")]
        public string PhysicalDeliveryOfficeName { get; set; }

        [JsonProperty("postalCode")]
        public string PostalCode { get; set; }

        [JsonProperty("preferredLanguage")]
        public string PreferredLanguage { get; set; }

        [JsonProperty("provisionedPlans")]
        public ProvisionedPlan[] ProvisionedPlans { get; set; }

        [JsonProperty("provisionedErrors")]
        public ProvisioningError[] ProvisioningErrors { get; set; }

        [JsonProperty("proxyAddresses")]
        public string [] ProxyAddresses { get; set; }

        [JsonProperty("sipProxyAddress")]
        public string SipProxyAddress { get; set; }

        [JsonProperty("state")]
        public string State { get; set; }

        [JsonProperty("streetAddress")]
        public string StreetAddress { get; set; }

        [JsonProperty("surname")]
        public string Surname { get; set; }

        [JsonProperty("telephoneNumber")]
        public string TelephoneNumber { get; set; }

        [JsonProperty("usageLocation")]
        public string UsageLocation { get; set; }

        [JsonProperty("userPrincipalName")]
        public string UserPrincipalName { get; set; }

        [JsonProperty("userType")]
        public string UserType { get; set; }
    }

    public class PasswordProfile
    {
        [JsonProperty("password")]
        public string Password { get; set; }

        [JsonProperty("forceChangePasswordNextLogin")]
        public bool? ForcePasswordNextLogin { get; set; }
    }

    public class AssignedLicense
    {
        [JsonProperty("disabledPlans")]
        public string[] disabledPlans { get; set; }

        [JsonProperty("skuId")]
        public string SkuId { get; set; }
    }

    public class AssignedPlan
    {
        [JsonProperty("assignedTimestamp")]
        public DateTime AssignedTimestamp { get; set; }

        [JsonProperty("capabilityStatus")]
        public string CapabilityStatus { get; set; }
        [JsonProperty("service")]
        public string Service { get; set; }

        [JsonProperty("servicePlanId")]
        public string ServicePlanId { get; set; }

    }

    public class ProvisionedPlan
    {
        [JsonProperty("capabilityStatus")]
        public string CapabilityStatus { get; set; }

        [JsonProperty("provisioningStatus")]
        public string ProvisioningStatus { get; set; }

        [JsonProperty("service")]
        public string Service { get; set; }
    }

    public class ProvisioningError
    {
        [JsonProperty("errorDetail")]
        public string ErrorDetail { get; set; }

        [JsonProperty("resolved")]
        public bool Resolved { get; set; }

        [JsonProperty("service")]
        public string Service { get; set; }

        [JsonProperty("timestamp")]
        public DateTime Timestamp { get; set; }
    }

    public class CreateUserParameters
    {
        [JsonProperty("accountEnabled")]
        public bool AccountEnabled { get; set; }
        [JsonProperty("displayName")]
        public string DisplayName { get; set; }
        [JsonProperty("mailNickName")]
        public string MailNickName { get; set; }
        [JsonProperty("passwordProfile")]
        public PasswordProfile PasswordProfile { get; set; }
        [JsonProperty("userPrincipalName")]
        public string UserPrincipalName { get; set; }
    }
}
