﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.PartnerCenter.DataModel
{
    public class Entitlements
    {

        [JsonProperty("items")]
        public EntitlementItem[] Items { get; set; }

        [JsonProperty("object_type")]
        public string ObjectType { get; set; }

        [JsonProperty("contract_version")]
        public string ContractVersion { get; set; }

        [JsonProperty("links")]
        public EntitlementLinks Links { get; set; }

        [JsonProperty("total_count")]
        public int TotalCount { get; set; }
    }

    public class EntitlementLinks
    {

        [JsonProperty("self")]
        public SelfLink Self { get; set; }

        [JsonProperty("add")]
        public AddLink Add { get; set; }
    }

    public class EntitlementItemLinks
    {

        [JsonProperty("self")]
        public SelfLink Self { get; set; }

        [JsonProperty("product")]
        public ProductLink Product { get; set; }

        [JsonProperty("consumptionhistory")]
        public ConsumptionhistoryLink Consumptionhistory { get; set; }

        [JsonProperty("currentconsumption")]
        public CurrentconsumptionLink Currentconsumption { get; set; }

        [JsonProperty("fulfillments")]
        public FulfillmentLink Fulfillments { get; set; }

        [JsonProperty("subscription")]
        public SubscriptionLink Subscription { get; set; }
    }

    public class EntitlementItem
    {

        [JsonProperty("id")]
        public string Id { get; set; }

        [JsonProperty("billing_subscription_uri")]
        public string BillingSubscriptionUri { get; set; }

        [JsonProperty("product_uri")]
        public string ProductUri { get; set; }

        [JsonProperty("quantity")]
        public int Quantity { get; set; }

        [JsonProperty("start_date")]
        public string StartDate { get; set; }

        [JsonProperty("end_date")]
        public string EndDate { get; set; }

        [JsonProperty("trial")]
        public bool Trial { get; set; }

        [JsonProperty("state")]
        public string State { get; set; }

        [JsonProperty("suspension_reasons")]
        public object[] SuspensionReasons { get; set; }

        [JsonProperty("friendly_name")]
        public object FriendlyName { get; set; }

        [JsonProperty("context")]
        public object Context { get; set; }

        [JsonProperty("etag")]
        public string Etag { get; set; }

        [JsonProperty("transition_sources")]
        public object[] TransitionSources { get; set; }

        [JsonProperty("transition_targets")]
        public object[] TransitionTargets { get; set; }

        [JsonProperty("transition_type")]
        public string TransitionType { get; set; }

        [JsonProperty("object_type")]
        public string ObjectType { get; set; }

        [JsonProperty("contract_version")]
        public string ContractVersion { get; set; }

        [JsonProperty("links")]
        public EntitlementItemLinks Links { get; set; }
    }

    public class ProductLink
    {

        [JsonProperty("href")]
        public string Href { get; set; }

        [JsonProperty("method")]
        public string Method { get; set; }
    }

    public class ConsumptionhistoryLink
    {

        [JsonProperty("href")]
        public string Href { get; set; }

        [JsonProperty("method")]
        public string Method { get; set; }
    }

    public class CurrentconsumptionLink
    {

        [JsonProperty("href")]
        public string Href { get; set; }

        [JsonProperty("method")]
        public string Method { get; set; }
    }

    public class FulfillmentLink
    {

        [JsonProperty("href")]
        public string Href { get; set; }

        [JsonProperty("method")]
        public string Method { get; set; }
    }

    public class SubscriptionLink
    {

        [JsonProperty("href")]
        public string Href { get; set; }

        [JsonProperty("method")]
        public string Method { get; set; }
    }
}
