﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.PartnerCenter.DataModel
{
    /// <summary>
    /// 
    /// </summary>
    public class EventStream
    {
        [JsonProperty("start_time")]
        public DateTime StartTtime { get; set; }

        [JsonProperty("page_size")]
        public int PageSize { get; set; }

        [JsonProperty("object_type")]
        public string ObjectType { get; set; }

        [JsonProperty("contract_version")]
        public string ContractVersion { get; set; }
    }

    /// <summary>
    /// 
    /// </summary>
    public class EventStreamCreation
    {
        [JsonProperty("start_time")]
        public DateTime StartTime { get; set; }

        [JsonProperty("page_size")]
        public int PageSize { get; set; }
    }

    public class EventStreamPage
    {
        [JsonProperty("items")]
        public EventItem[] EventItems { get; set; }
        [JsonProperty("object_type")]
        public string objectType { get; set; }
        [JsonProperty("contract_version")]
        public string ContractVersion { get; set; }

        [JsonProperty("links")]
        public EventStreamPageLink Links { get; set; }
    }

    public class EventItem
    {
        [JsonProperty("type")]
        public string Type { get; set; }

        [JsonProperty("subscription_uri")]
        public string SubscriptionUri { get; set; }

        [JsonProperty("recipient_customer_uri")]
        public string RecipientCustomerUri { get; set; }

        [JsonProperty("event_date")]
        public DateTime EventDate { get; set; }

        [JsonProperty("data")]
        public string Data { get; set; }
    }

    public class EventStreamPageLink
    {
        [JsonProperty("completion")]
        public CompletionLink CompletionLink { get; set; }
    }

    public class CompletionLink
    {
        [JsonProperty("href")]
        public string Href { get; set; }
        [JsonProperty("method")]
        public string Method { get; set; }
    }
}
