﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.PartnerCenter.DataModel
{
    /// <summary>
    /// Class encauplates the request for creating a new customer
    /// </summary>
    public class NewCustomer
    {
        [JsonProperty("domain_prefix")]
        public string DomainPrefix { get; set; }

        [JsonProperty("user_name")]
        public string UserName { get; set; }

        [JsonProperty("password")]
        public string Password { get; set; }

        [JsonProperty("profile")]
        public NewCustomerProfile Profile { get; set; }
    }

    /// <summary>
    /// 
    /// </summary>
    public class NewCustomerProfile
    {
        [JsonProperty("first_name")]
        public string FirstName { get; set; }

        [JsonProperty("last_name")]
        public string LastName { get; set; }

        [JsonProperty("email")]
        public string Email { get; set; }

        [JsonProperty("culture")]
        public string Culture { get; set; }

        [JsonProperty("language")]
        public string Language { get; set; }

        [JsonProperty("company_name")]
        public string CompanyName { get; set; }

        [JsonProperty("default_address")]
        public NewCustomerDefaultAddress DefaultAddress { get; set; }

        [JsonProperty("type")]
        public string Type { get; set; }
    }

    /// <summary>
    /// 
    /// </summary>
    public class NewCustomerDefaultAddress
    {
        [JsonProperty("first_name")]
        public string FirstName { get; set; }

        [JsonProperty("last_name")]
        public string LastName { get; set; }

        [JsonProperty("first_name_pronounciation")]
        public string FirstNameProunication { get; set; }

        [JsonProperty("last_name_pronounciation")]
        public string LastNameProunciation { get; set; }

        [JsonProperty("address_line1")]
        public string AddressLine1 { get; set; }

        [JsonProperty("address_line2")]
        public string AddressLine2 { get; set; }

        [JsonProperty("address_line3")]
        public string AddressLine3 { get; set; }

        [JsonProperty("city")]
        public string City { get; set; }

        [JsonProperty("region")]
        public string Region { get; set; }

        [JsonProperty("postal_code")]
        public string PostalCode { get; set; }

        [JsonProperty("country")]
        public string Country { get; set; }

        [JsonProperty("phone_number")]
        public string PhoneNumber { get; set; }

    }

    /// <summary>
    /// class encapulates the request for updating customer profile 
    /// </summary>
    public class UpdateCustomerProfile
    {
        [JsonProperty("id")]
        public string Id { get; set; }
        [JsonProperty("email")]
        public string Email { get; set; }

        [JsonProperty("culture")]
        public string Culture { get; set; }

        [JsonProperty("language")]
        public string Language { get; set; }

        [JsonProperty("company_name")]
        public string CompanyName { get; set; }

        [JsonProperty("default_address")]
        public NewCustomerDefaultAddress DefaultAddress { get; set; }

        [JsonProperty("type")]
        public string Type { get; set; }
    }
}
