﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.PartnerCenter.DataModel
{
    /// <summary>
    /// Class encapulates the request for creating or updating order
    /// </summary>
    public class NewOrder
    {
        [JsonProperty("line_items")]
        public NewUpdateOrderLineItem[] LineItems { get; set; }

        [JsonProperty("recipient_customer_id")]
        public string RecipientCustomerId { get; set; }
    }

    public class UpdateOrder
    {
        [JsonProperty("line_items")]
        public NewUpdateOrderLineItem[] LineItems { get; set; }
    }

    /// <summary>
    /// class encapulates the request order line item
    /// </summary>
    public class NewUpdateOrderLineItem
    {
        [JsonProperty("line_item_number")]
        public int LineItemNumber { get; set; }

        [JsonProperty("offer_uri")]
        public string OfferUri { get; set; }

        [JsonProperty("quantity")]
        public int Quantity { get; set; }

        [JsonProperty("reference_entitlement_uris")]
        public string[] ReferenceEntitlementUris { get; set; }
    }
}
