﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.PartnerCenter.DataModel
{
    /// <summary>
    /// Class represents the offer could be provisioned by CSP partner. Check the offer excel spreadsheet can be downloaded at https://partnercenter.microsoft.com
    /// </summary>
    public class Offer
    {
        /// <summary>
        /// Name of the offer
        /// </summary>
        public string Name { get; set; }

        /// <summary>
        /// Uri of the offer
        /// </summary>
        public string Uri { get; set; }

        /// <summary>
        /// Offer Id
        /// </summary>
        public string Id { get; set; }

        /// <summary>
        /// Minimum allowed quantity 
        /// </summary>
        public int Minimum { get; set; }

        /// <summary>
        /// Maximum allowed quantity
        /// </summary>
        public int Maximum { get; set; }

        /// <summary>
        /// List of offer ids that this offer can be converted to
        /// </summary>
        public List<string> ConvertibleOffers { get; set; }

        /// <summary>
        /// List of offers that this offer depends on 
        /// If any of the offers in the list is purchased then this offer can be purchased as well
        /// </summary>
        public List<string> DependentOffers { get; set; }
    }
}
