﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.PartnerCenter.DataModel
{
    public class Profiles
    {

        [JsonProperty("item_count")]
        public int ItemCount { get; set; }

        [JsonProperty("items")]
        public ProfileItem[] Items { get; set; }

        [JsonProperty("links")]
        public ProfileLinks ProfileLinks{ get; set; }

        [JsonProperty("object_type")]
        public string ObjectType { get; set; }
    }

    public class DefaultAddress
    {

        [JsonProperty("id")]
        public string Id { get; set; }

        [JsonProperty("country")]
        public string Country { get; set; }

        [JsonProperty("region")]
        public string Region { get; set; }

        [JsonProperty("city")]
        public string City { get; set; }

        [JsonProperty("address_line1")]
        public string AddressLine1 { get; set; }
        [JsonProperty("address_line2")]
        public string AddressLine2 { get; set; }

        [JsonProperty("address_line3")]
        public string AddressLine3 { get; set; }

        [JsonProperty("postal_code")]
        public string PostalCode { get; set; }

        [JsonProperty("first_name")]
        public string FirstName { get; set; }

        [JsonProperty("last_name")]
        public string LastName { get; set; }

        [JsonProperty("phone_number")]
        public string PhoneNumber { get; set; }

        [JsonProperty("links")]
        public CustomerLinks CustomerLinks { get; set; }

        [JsonProperty("object_type")]
        public string ObjectType { get; set; }
    }

    public class SnapshotLink
    {

        [JsonProperty("href")]
        public string Href { get; set; }

        [JsonProperty("method")]
        public string Method { get; set; }
    }

    public class UpdateLink
    {

        [JsonProperty("href")]
        public string Href { get; set; }

        [JsonProperty("method")]
        public string Method { get; set; }
    }

    public class DefaultAddressLink
    {

        [JsonProperty("href")]
        public string Href { get; set; }

        [JsonProperty("method")]
        public string Method { get; set; }
    }

    public class ProfileItemLink
    {

        [JsonProperty("self")]
        public SelfLink Self { get; set; }

        [JsonProperty("snapshot")]
        public SnapshotLink Snapshot { get; set; }

        [JsonProperty("update")]
        public UpdateLink Update { get; set; }

        [JsonProperty("default_address")]
        public DefaultAddressLink DefaultAddressLink { get; set; }
    }

    public class ProfileItem
    {
        [JsonProperty("first_name")]
        public string FirstName { get; set; }

        [JsonProperty("last_name")]
        public string LastName { get; set; }

        [JsonProperty("email")]
        public string Email { get; set; }

        [JsonProperty("company_name")]
        public string CompanyName { get; set; }

        [JsonProperty("language")]
        public string Language { get; set; }

        [JsonProperty("customer_id")]
        public string CustomerId { get; set; }

        [JsonProperty("id")]
        public string Id { get; set; }

        [JsonProperty("snapshot_id")]
        public string SnapshotId { get; set; }

        [JsonProperty("type")]
        public string Type { get; set; }

        [JsonProperty("default_address_id")]
        public string DefaultAddressId { get; set; }

        [JsonProperty("default_address")]
        public DefaultAddress DefaultAddress { get; set; }

        [JsonProperty("culture")]
        public string Culture { get; set; }

        [JsonProperty("etag")]
        public string Etag { get; set; }

        [JsonProperty("links")]
        public ProfileItemLink ProfileItemLink { get; set; }

        [JsonProperty("object_type")]
        public string ObjectType { get; set; }
    }

    public class ProfileLinks
    {

        [JsonProperty("add")]
        public AddLink Add { get; set; }
    }
}
