﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.PartnerCenter.DataModel
{
    public class Subscriptions
    {

        [JsonProperty("object_type")]
        public string ObjectType { get; set; }

        [JsonProperty("contract_version")]
        public string ContractVersion { get; set; }

        [JsonProperty("items")]
        public SubscriptionItem[] Items { get; set; }

        [JsonProperty("total_count")]
        public int TotalCount { get; set; }

        [JsonProperty("links")]
        public SubscriptionLinks Links { get; set; }
    }

    public class SubscriptionLinks
    {

        [JsonProperty("self")]
        public SelfLink Self { get; set; }
    }

    public class SubscriptionItem
    {

        [JsonProperty("id")]
        public string Id { get; set; }

        [JsonProperty("order_id")]
        public string OrderId { get; set; }

        [JsonProperty("creation_date")]
        public string CreationDate { get; set; }

        [JsonProperty("effective_start_date")]
        public string EffectiveStartDate { get; set; }

        [JsonProperty("commitment_end_date")]
        public string CommitmentEndDate { get; set; }

        [JsonProperty("quantity")]
        public int Quantity { get; set; }

        [JsonProperty("state")]
        public string State { get; set; }

        [JsonProperty("etag")]
        public string Etag { get; set; }

        [JsonProperty("suspension_reasons")]
        public object[] SuspensionReasons { get; set; }

        [JsonProperty("offer_uri")]
        public string OfferUri { get; set; }

        [JsonProperty("object_type")]
        public string ObjectType { get; set; }

        [JsonProperty("contract_version")]
        public string ContractVersion { get; set; }

        [JsonProperty("links")]
        public SubscriptionItemLinks Links { get; set; }
    }

    public class OrderLink
    {

        [JsonProperty("href")]
        public string Href { get; set; }

        [JsonProperty("method")]
        public string Method { get; set; }
    }

    public class OfferLink
    {

        [JsonProperty("href")]
        public string Href { get; set; }

        [JsonProperty("method")]
        public string Method { get; set; }
    }

    public class UpdateFriendlyNameLink
    {

        [JsonProperty("href")]
        public string Href { get; set; }

        [JsonProperty("method")]
        public string Method { get; set; }
    }

    public class TransitionSourcesLink
    {

        [JsonProperty("href")]
        public string Href { get; set; }

        [JsonProperty("method")]
        public string Method { get; set; }
    }

    public class TransitionTargetsLink
    {

        [JsonProperty("href")]
        public string Href { get; set; }

        [JsonProperty("method")]
        public string Method { get; set; }
    }

    public class AddSuspensionLink
    {

        [JsonProperty("href")]
        public string Href { get; set; }

        [JsonProperty("method")]
        public string Method { get; set; }
    }

    public class RemoveSuspensionLink
    {

        [JsonProperty("href")]
        public string Href { get; set; }

        [JsonProperty("method")]
        public string Method { get; set; }
    }

    public class UpdateAdvisorPartnerIdLink
    {

        [JsonProperty("href")]
        public string Href { get; set; }

        [JsonProperty("method")]
        public string Method { get; set; }
    }

    public class EntitlementLink
    {

        [JsonProperty("href")]
        public string Href { get; set; }

        [JsonProperty("method")]
        public string Method { get; set; }
    }

    public class SubscriptionItemLinks
    {

        [JsonProperty("self")]
        public SelfLink Self { get; set; }

        [JsonProperty("order")]
        public OrderLink Order { get; set; }

        [JsonProperty("offer")]
        public OfferLink Offer { get; set; }

        [JsonProperty("update_friendly_name")]
        public UpdateFriendlyNameLink UpdateFriendlyName { get; set; }

        [JsonProperty("transition_sources")]
        public TransitionSourcesLink TransitionSources { get; set; }

        [JsonProperty("transition_targets")]
        public TransitionTargetsLink TransitionTargets { get; set; }

        [JsonProperty("add_suspension")]
        public AddSuspensionLink AddSuspension { get; set; }

        [JsonProperty("remove_suspension")]
        public RemoveSuspensionLink RemoveSuspension { get; set; }

        [JsonProperty("update_advisor_partner_id")]
        public UpdateAdvisorPartnerIdLink UpdateAdvisorPartnerId { get; set; }

        [JsonProperty("entitlement")]
        public EntitlementLink Entitlement { get; set; }
    }

    public class UpdateSubscriptionAdvisorId
    {
        [JsonProperty("advisor_partner_id")]
        public string AdvisorPartnerId { get; set; }
    }

    public class UpdateSubscriptionFriendlyName
    {
        [JsonProperty("friendly_name")]
        public string FriendlyName { get; set; }
    }
}
