﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderManagement.PartnerCenter.DataModel
{
    public class UsageRecord
    {
        [JsonProperty("items")]
        public UsageRecordItem[] Items { get; set; }

        [JsonProperty("object_type")]
        public string ObjectType { get; set; }

        [JsonProperty("contract_version")]
        public string ContractVersion { get; set; }

        [JsonProperty("links")]
        public UsageRecordLinks Links { get; set; }
    }

    public class UsageRecordItem
    {
        [JsonProperty("entitlement_id")]
        public string EntitlementId { get; set; }

        [JsonProperty("usage_start_time")]
        public DateTime UsageStartTime { get; set; }

        [JsonProperty("usage_end_time")]
        public DateTime UsageEndTime { get; set; }

        [JsonProperty("object_type")]
        public string ObjectType { get; set; }

        [JsonProperty("meter_name")]
        public string MeterName { get; set; }

        [JsonProperty("meter_category")]
        public string MeterCategory { get; set; }

        [JsonProperty("meter_sub_category")]
        public string MeterSubcategory { get; set; }
        
        [JsonProperty("unit")]
        public string Unit { get; set; }

        [JsonProperty("meter_id")]
        public string MeterId { get; set; }

        [JsonProperty("info_fields")]
        public InfoFields InfoFields { get; set; }

        [JsonProperty("quantity")]
        public double Quantity { get; set; }
    }

    public class InfoFields
    {
        [JsonProperty("MeteredRegion")]
        public string MeteredRegion { get; set; }

        [JsonProperty("MeteredService")]
        public string MeteredService { get; set; }

        [JsonProperty("MeteredServiceType")]
        public string MeteredServiceType { get; set; }

        [JsonProperty("Project")]
        public string Project { get; set; }
    }

    public class UsageRecordLinks
    {
        [JsonProperty("links")]
        public SelfLink Self { get; set; }
    }
}
