﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderControlPanel.Controls.Validation
{
    public class ValidationGroupAttribute : Attribute
    {
        public const string DefaultGroupName = "Default";

        /// <summary>
        /// Default constructor
        /// </summary>
        public ValidationGroupAttribute()
            : base()
        {
            GroupName = DefaultGroupName;
            IncludeInErrorsValidation = true;
        }

        /// <summary>
        /// A name which defines a group of properties which should be validated together 
        /// </summary>
        public string GroupName { get; set; }

        /// <summary>
        /// Get/Set as flag to indicate whether validation for a field should be applied when Error/HasError is applied
        /// </summary>
        public bool IncludeInErrorsValidation { get; set; }
    }
}
