﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Serialization;

namespace Microsoft.Samples.CloudSolutionProviderControlPanel.Models
{
    /// <summary>
    /// Class holds the configuration setting for the sample
    /// </summary>
    [Serializable]
    [XmlType(AnonymousType = true)]
    [XmlRoot(Namespace = "", IsNullable = false)]
    public partial class ConfigurationSettings
    {
        private string resellerTenantDomainName;
        private string resellerTenantId;
        private string partnercenterAppId;
        private string partnercenterAppSecret;
        private string clientId;
        private string managementAppId;
        private string managementAppSecret;
        private List<AzureSubscriptionServicePrincipal> azureSubscriptionServicePrincipals;

        [XmlElement]
        public string ResellerTenantDomainName
        {
            get
            {
                return resellerTenantDomainName;
            }
            set
            {
                resellerTenantDomainName = value;
            }
        }

        [XmlElement]
        public string ResellerTenantId
        {
            get
            {
                return resellerTenantId;
            }
            set
            {
                resellerTenantId = value;
            }
        }

        [XmlElement]
        public string PartnerCenterAppId
        {
            get
            {
                return partnercenterAppId;
            }
            set
            {
                partnercenterAppId = value;
            }
        }

        [XmlElement]
        public string PartnerCenterAppSecret
        {
            get
            {
                return partnercenterAppSecret;
            }
            set
            {
                partnercenterAppSecret = value;
            }
        }

        [XmlElement]
        public string ClientId
        {
            get
            {
                return clientId;
            }
            set
            {
                clientId = value;
            }
        }

        [XmlElement]
        public string ManagementAppId
        {
            get
            {
                return managementAppId;
            }
            set
            {
                managementAppId = value;
            }
        }

        [XmlElement]
        public string ManagementAppSecret
        {
            get
            {
                return managementAppSecret;
            }
            set
            {
                managementAppSecret = value;
            }
        }

        [XmlArray]
        [XmlArrayItem("AzureSubscriptionServicePrincipal", typeof(AzureSubscriptionServicePrincipal))]
        public List<AzureSubscriptionServicePrincipal> AzureSubscriptionServicePrincipals
        {
            get
            {
                return this.azureSubscriptionServicePrincipals;
            }
            set
            {
                this.azureSubscriptionServicePrincipals = value;
            }
        }
    }

    [Serializable]
    [XmlType(AnonymousType = true)]
    public partial class AzureSubscriptionServicePrincipal
    {
        private string subscriptionId;
        private string servicePrincipal;
        private string secret;

        [XmlAttribute]
        public string SubscriptionId
        {
            get
            {
                return this.subscriptionId;
            }
            set
            {
                this.subscriptionId = value;
            }
        }

        [XmlAttribute]
        public string ServicePrincipal
        {
            get
            {
                return this.servicePrincipal;
            }
            set
            {
                this.servicePrincipal = value;
            }
        }

        [XmlAttribute]
        public string Secret
        {
            get
            {
                return this.secret;
            }
            set
            {
                this.secret = value;
            }
        }
    }
}
