﻿using Caliburn.Micro;
using Microsoft.Samples.CloudSolutionProviderControlPanel.Models.Events;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderControlPanel.Utility
{
    /// <summary>
    /// Trace Logger calss encapulates methods to log trace events by publishing the trace events
    /// </summary>
    public class Logger
    {
        public static void WriteLine(IEventAggregator eventAggregator, TraceEvent traceEvent)
        {
            eventAggregator.PublishOnBackgroundThread(traceEvent);
        }

        public static void InfoLine(IEventAggregator eventAggregator, string format, params object[] args)
        {
            TraceEvent traceEvent = new TraceEvent(TraceEventType.Info, string.Format(format, args));
            WriteLine(eventAggregator, traceEvent);
        }

        public static void WarnLine(IEventAggregator eventAggregator, string format, params object[] args)
        {
            TraceEvent traceEvent = new TraceEvent(TraceEventType.Warning, string.Format(format, args));
            WriteLine(eventAggregator, traceEvent);
        }

        public static void ErrorLine(IEventAggregator eventAggregator, string format, params object[] args)
        {
            TraceEvent traceEvent = new TraceEvent(TraceEventType.Error, string.Format(format, args));
            WriteLine(eventAggregator, traceEvent);
        }
    }
}
