﻿using Caliburn.Micro;
using Microsoft.Samples.AuthenticationManagement;
using Microsoft.Samples.CloudSolutionProviderManagement.Azure.DataModel.SQLDatabase;
using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderControlPanel.ViewModels.Azure.AzureSQL
{
    [Export(typeof(ElasticPoolViewModel))]
    public class ElasticPoolViewModel : Screen
    {
        private readonly IWindowManager windowManager;
        private readonly IEventAggregator eventAggregator;
        private string tenantId;
        private string subscriptionId;
        private string resourceGroupName;
        private string serverName;
        private ElasticPool poolItem;
        private LoginType authType;

        [ImportingConstructor]
        public ElasticPoolViewModel(IWindowManager winMgr, IEventAggregator evt, string tId, string sId, string rgName, string sName, ElasticPool item, LoginType loginType)
        {
            windowManager = winMgr;
            eventAggregator = evt;
            tenantId = tId;
            subscriptionId = sId;
            resourceGroupName = rgName;
            serverName = sName;
            poolItem = item;
            authType = loginType;
        }

        public string ElasticPoolId
        {
            get
            {
                return poolItem.Id;
            }
        }

        public string ElasticPoolName
        {
            get
            {
                return poolItem.Name;
            }
        }

        public string ElsticPoolType
        {
            get
            {
                return poolItem.Type;
            }
        }

        public string Location
        {
            get
            {
                return poolItem.Location;
            }
        }

        public DateTime? CreationDate
        {
            get
            {
                return poolItem.Properties.CreationDate;
            }
        }

        public string ElasticPoolState
        {
            get
            {
                return poolItem.Properties.State;
            }
        }

        public string ElasticPoolEdition
        {
            get
            {
                return poolItem.Properties.Edition;
            }
        }

        public long ElasticPoolDtu
        {
            get
            {
                return poolItem.Properties.Dtu;
            }
        }

        public long StorageMB
        {
            get
            {
                return poolItem.Properties.StorageMB;
            }
        }

        public long DatabaseMinDtu
        {
            get
            {
                return poolItem.Properties.DatabaseDtuMin;
            }
        }

        public long DatabaseMaxDtu
        {
            get
            {
                return poolItem.Properties.DatabaseDtuMax;
            }
        }
    }
}
