﻿using Caliburn.Micro;
using Microsoft.Samples.AuthenticationManagement;
using Microsoft.Samples.CloudSolutionProviderControlPanel.Utility;
using Microsoft.Samples.CloudSolutionProviderManagement.Azure.DataModel.SQLDatabase;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace Microsoft.Samples.CloudSolutionProviderControlPanel.ViewModels.Azure.AzureSQL
{
    [Export(typeof(ServerViewModel))]
    public class ServerViewModel : Conductor<object>
    {
        private readonly IWindowManager windowManager;
        private readonly IEventAggregator eventAggregator;
        private string tenantId;
        private string subscriptionId;
        private string resourceGroupName;
        private Server serverItem;
        private LoginType authType;

        [ImportingConstructor]
        public ServerViewModel(IWindowManager winMgr, IEventAggregator evt, string tId, string sId, string rgName, Server item, LoginType loginType)
        {
            windowManager = winMgr;
            eventAggregator = evt;
            tenantId = tId;
            subscriptionId = sId;
            resourceGroupName = rgName;
            serverItem = item;
            authType = loginType;
        }

        public string ServerName
        {
            get
            {
                return serverItem.Name;
            }
        }

        public string Location
        {
            get
            {
                return serverItem.Location;
            }
        }

        public string Version
        {
            get
            {
                return serverItem.Properties.Version;
            }
        }

        public void DatabaseList()
        {
            ActivateItem(new DatabaseListViewModel(windowManager, eventAggregator, tenantId, subscriptionId, resourceGroupName, serverItem.Name, authType));
        }

        public void ElasticPoolList()
        {
            ActivateItem(new ElasticPoolListViewModel(windowManager, eventAggregator, tenantId, subscriptionId, resourceGroupName, serverItem.Name, authType));
        }
        
    }
}
