﻿using Caliburn.Micro;
using Microsoft.Samples.AuthenticationManagement;
using Microsoft.Samples.CloudSolutionProviderManagement.Azure.DataModel.Network;
using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderControlPanel.ViewModels.Azure.Network
{
    [Export(typeof(NetworkInterfaceViewModel))]
    public class NetworkInterfaceViewModel : Screen
    {
        private readonly IWindowManager windowManager;
        private readonly IEventAggregator eventAggregator;
        private string tenantId;
        private string subscriptionId;
        private string resourceGroupName;
        private NetworkInterface nicItem;
        private LoginType authType;

        [ImportingConstructor]
        public NetworkInterfaceViewModel(IWindowManager winMgr, IEventAggregator evt, string tId, string sId, string rgName, NetworkInterface item, LoginType loginType)
        {
            windowManager = winMgr;
            eventAggregator = evt;
            tenantId = tId;
            subscriptionId = sId;
            resourceGroupName = rgName;
            nicItem = item;
            authType = loginType;
        }

        public string NetworkInterfaceId
        {
            get
            {
                return nicItem.Id;
            }
        }

        public string NetworkInterfaceName
        {
            get
            {
                return nicItem.Name;
            }
        }

        public string Location
        {
            get
            {
                return nicItem.Location;
            }
        }

        public string NetworkInterfaceType
        {
            get
            {
                return nicItem.Type;
            }
        }

        public bool EnableForwarding
        {
            get
            {
                return nicItem.Properties.EnableIPForwarding;
            }
        }
        
        public string MACAddress
        {
            get
            {
                return nicItem.Properties.MacAddress;
            }
        } 

        public string ProvisioningState
        {
            get
            {
                return nicItem.Properties.ProvisioningState;
            }
        }

        public bool? Primary
        {
            get
            {
                return nicItem.Properties.Primary;
            }
        }
    }
}
