﻿using Caliburn.Micro;
using Microsoft.Samples.AuthenticationManagement;
using Microsoft.Samples.CloudSolutionProviderManagement.Azure.DataModel.ResourceManager;
using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderControlPanel.ViewModels.Azure.ResourceManagement
{
    [Export(typeof(DeploymentViewModel))]
    public class DeploymentViewModel : Screen
    {
        private readonly IWindowManager windowManager;
        private readonly IEventAggregator eventAggregator;
        private string tenantId;
        private string subscriptionId;
        private Deployment deploymentItem;
        private LoginType authType;

        [ImportingConstructor]
        public DeploymentViewModel(IWindowManager winMgr, IEventAggregator evt, string tId, string sId, string rgName, Deployment d, LoginType loginType)
        {
            windowManager = winMgr;
            eventAggregator = evt;
            tenantId = tId;
            subscriptionId = sId;
            deploymentItem = d;
            authType = loginType;
        }

        public string DeploymentId
        {
            get
            {
                return deploymentItem.id;
            }
        }

        public string DeploymentName
        {
            get
            {
                return deploymentItem.Name;
            }
        }

        public string DeploymentMode
        {
            get
            {
                return deploymentItem.Properties.DeploymentMode;
            }
        }

        public string TemplateName
        {
            get
            {
                return deploymentItem.Properties.Template;
            }
        }

        public string ProvisioningState
        {
            get
            {
                return deploymentItem.Properties.ProvisioningState;
            }
        }

        public DateTime Timestamp
        {
            get
            {
                return deploymentItem.Properties.TimeStamp;
            }
        }

        public Provider[] Providers
        {
            get
            {
                return deploymentItem.Properties.Providers;
            }
        }
    }
}
