﻿using Caliburn.Micro;
using Microsoft.Samples.AuthenticationManagement;
using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderControlPanel.ViewModels.Azure.Storage
{
    [Export(typeof(AzureStorageViewModel))]
    public class AzureStorageViewModel : Conductor<object>
    {
        private readonly IWindowManager windowManager;
        private readonly IEventAggregator eventAggregator;
        private string tenantId;
        private string subscriptionId;
        private string resourceGroupName;
        private LoginType authType;

        [ImportingConstructor]
        public AzureStorageViewModel(IWindowManager winMgr, IEventAggregator evt, string tId, string sId, string rgName, LoginType loginType)
        {
            windowManager = winMgr;
            eventAggregator = evt;
            tenantId = tId;
            subscriptionId = sId;
            resourceGroupName = rgName;
            authType = loginType;
        }

        public void StorageAccounts()
        {
            ActivateItem(new StorageAccountListViewModel(windowManager, eventAggregator, tenantId, subscriptionId, resourceGroupName, authType));
        }
    }
}
