﻿using Caliburn.Micro;
using Microsoft.Samples.AuthenticationManagement;
using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderControlPanel.ViewModels.Azure.VirtualMachine
{
    [Export(typeof(HardwareProfileViewModel))]
    public class HardwareProfileViewModel : Screen
    {
        private readonly IWindowManager windowManager;
        private readonly IEventAggregator eventAggregator;
        private string tenantId;
        private string subscriptionId;
        private string resourceGroupName;
        private CloudSolutionProviderManagement.Azure.DataModel.Compute.VirtualMachine vmItem;
        private LoginType authType;

        [ImportingConstructor]
        public HardwareProfileViewModel(IWindowManager winMgr, IEventAggregator evt, string tId, string sId, string rgName, CloudSolutionProviderManagement.Azure.DataModel.Compute.VirtualMachine item, LoginType loginType)
        {
            windowManager = winMgr;
            eventAggregator = evt;
            tenantId = tId;
            subscriptionId = sId;
            resourceGroupName = rgName;
            vmItem = item;
            authType = loginType;
        }

        public string VirtualMachineSize
        {
            get
            {
                return vmItem.Properties.HardwareProfile.VirtualMachineSize;
            }
        }


    }
}
