﻿using Caliburn.Micro;
using Microsoft.Samples.AuthenticationManagement;
using Microsoft.Samples.CloudSolutionProviderManagement.Azure.DataModel.Compute;
using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderControlPanel.ViewModels.Azure.VirtualMachine
{
    [Export(typeof(StorageProfileViewModel))]
    public class StorageProfileViewModel : Screen
    {
        private readonly IWindowManager windowManager;
        private readonly IEventAggregator eventAggregator;
        private string tenantId;
        private string subscriptionId;
        private string resourceGroupName;
        private CloudSolutionProviderManagement.Azure.DataModel.Compute.VirtualMachine vmItem;
        private LoginType authType;

        [ImportingConstructor]
        public StorageProfileViewModel(IWindowManager winMgr, IEventAggregator evt, string tId, string sId, string rgName, CloudSolutionProviderManagement.Azure.DataModel.Compute.VirtualMachine item, LoginType loginType)
        {
            windowManager = winMgr;
            eventAggregator = evt;
            tenantId = tId;
            subscriptionId = sId;
            resourceGroupName = rgName;
            vmItem = item;
            authType = loginType;
        }

        public string ImagePublisher
        {
            get
            {
                return vmItem.Properties.StorageProfile.ImageReference.Publisher;
            }
        }

        public string ImageSku
        {
            get
            {
                return vmItem.Properties.StorageProfile.ImageReference.Sku;
            }
        }

        public string OSDiskCaching
        {
            get
            {
                return vmItem.Properties.StorageProfile.OSDisk.caching;
            }
        }

        public string OSDiskVhd
        {
            get
            {
                return vmItem.Properties.StorageProfile.OSDisk.VirtualHardDisk.Uri;
            }
        }

        public string OperatingSystemType
        {
            get
            {
                return vmItem.Properties.StorageProfile.OSDisk.OperatingSystemType;
            }
        }

        public DataDisk[] DataDisks
        {
            get
            {
                return vmItem.Properties.StorageProfile.DataDisks;
            }
        }
    }
}
