﻿using Caliburn.Micro;
using Microsoft.Samples.AuthenticationManagement;
using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderControlPanel.ViewModels.AzureActiveDirectory.Application
{
    [Export(typeof(ApplicationViewModel))]
    public class ApplicationViewModel : Screen
    {
        private readonly IWindowManager windowManager;
        private readonly IEventAggregator eventAggregator;
        private string tenantGuid;
        private CloudSolutionProviderManagement.AzureActiveDirectory.DataModel.Application application;
        private LoginType authType;

        [ImportingConstructor]
        public ApplicationViewModel(IWindowManager winMgr, IEventAggregator evt, string tenantId, CloudSolutionProviderManagement.AzureActiveDirectory.DataModel.Application app, LoginType loginType)
        {
            windowManager = winMgr;
            eventAggregator = evt;
            tenantGuid = tenantId;
            application = app;
            authType = loginType;
        }

        public string ApplicationId
        {
            get
            {
                return application.AppId;
            }
        }

        public string AppDisplayName
        {
            get
            {
                return application.DisplayName;
            }
        }

        public bool IsMultiTenant
        {
            get
            {
                return application.AvailableToOtherTenant;
            }
        }
    }
}
