﻿using Caliburn.Micro;
using Microsoft.Samples.AuthenticationManagement;
using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderControlPanel.ViewModels.AzureActiveDirectory.Group
{
    [Export(typeof(GroupViewModel))]
    public class GroupViewModel : Screen
    {
        private readonly IWindowManager windowManager;
        private readonly IEventAggregator eventAggregator;
        private string tenantGuid;
        private CloudSolutionProviderManagement.AzureActiveDirectory.DataModel.Group group;
        private LoginType authType;

        [ImportingConstructor]
        public GroupViewModel(IWindowManager winMgr, IEventAggregator evt, string tenantId, CloudSolutionProviderManagement.AzureActiveDirectory.DataModel.Group gp, LoginType loginType)
        {
            windowManager = winMgr;
            eventAggregator = evt;
            tenantGuid = tenantId;
            group = gp;
            authType = loginType;
        }

        public string GroupDisplayName
        {
            get
            {
                return group.DisplayName;
            }
        }

        public string ObjectId
        {
            get { return group.ObjectId; }
        }

        public string ObjectType
        {
            get
            {
                return group.ObjectType;
            }
        }

        public string Description
        {
            get
            {
                return group.Description;
            }
        }

        public string Mail
        {
            get
            {
                return group.Mail;
            }
        }
    }
}
