﻿using Caliburn.Micro;
using Microsoft.Samples.CloudSolutionProviderManagement.AzureActiveDirectory.DataModel;
using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderControlPanel.ViewModels.AzureActiveDirectory.User
{
    [Export(typeof(UserViewModel))]
    public class UserViewModel : Screen
    {
        private readonly IWindowManager windowManager;
        private readonly IEventAggregator eventAggregator;
        CloudSolutionProviderManagement.AzureActiveDirectory.DataModel.User userObject = null;

        [ImportingConstructor]
        public UserViewModel(IWindowManager winMgr, IEventAggregator evt, string tenantId, CloudSolutionProviderManagement.AzureActiveDirectory.DataModel.User user)
        {
            windowManager = winMgr;
            eventAggregator = evt;
            userObject = user;
        }

        public string FirstName
        {
            get
            {
                return userObject.GivenName;
            }
        }

        public string LastName
        {
            get
            {
                return userObject.Surname;
            }
        }

        public string UserDisplayName
        {
            get
            {
                return userObject.DisplayName;
            }
        }

        public string UserName
        {
            get
            {
                return userObject.UserPrincipalName;
            }
        }

        public string ObjectId
        {
            get
            {
                return userObject.ObjectId;
            }
        }

        public AssignedPlan[] AssignedPlans
        {
            get
            {
                return userObject.AssignedPlans;
            }
        }

        public ProvisionedPlan[] ProvisiongedPlans
        {
            get
            {
                return userObject.ProvisionedPlans;
            }
        }

        public AssignedLicense[] AssignedLicenses
        {
            get
            {
                return userObject.AssignedLicenses;
            }
        }
    }
}
