﻿using Caliburn.Micro;
using Microsoft.Samples.CloudSolutionProviderManagement.PartnerCenter.DataModel;
using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace Microsoft.Samples.CloudSolutionProviderControlPanel.ViewModels.PartnerCenter.Order
{
    [Export(typeof(OfferViewModel))]
    public class OfferViewModel : Screen
    {
        private string offerName;
        private string offerId;
        private string offerUri;
        private bool selected=false;
        private int quantity= 1;
        private OfferCategory category;
        private Visibility showQualitityInput = Visibility.Collapsed;

        [ImportingConstructor]
        public OfferViewModel(OfferCategory cat, string name, string id, string uri)
        {
            offerName = name;
            offerId = id;
            offerUri = uri;
            category = cat;
            if (offerId.ToLower().Contains("ms-azr"))
                ShowQualitityInput = Visibility.Collapsed;
            else
                ShowQualitityInput = Visibility.Visible;
        }

        public string OfferName
        {
            get
            {
                return offerName;
            }
        }

        public OfferCategory Category
        {
            get
            {
                return category;
            }
        }

        public int Quantity
        {
            get
            {
                return quantity;
            }
            set
            {
                quantity = value;
                NotifyOfPropertyChange(() => Quantity);
            }
        }

        public Visibility ShowQualitityInput
        {
            get
            {
                return showQualitityInput;
            }
            set
            {
                showQualitityInput = value;
                NotifyOfPropertyChange(() => ShowQualitityInput);
            }
        }

        public string OfferId
        {
            get
            {
                return offerId;
            }
        }

        public string OfferUri
        {
            get
            {
                return offerUri;
            }
        }

        public bool IsSelected
        {
            get
            {
                return selected;
            }
            set
            {
                selected = value;
                NotifyOfPropertyChange(() => IsSelected);
            }
        }
    }
}
