﻿using Caliburn.Micro;
using Microsoft.Samples.CloudSolutionProviderManagement.PartnerCenter.DataModel;
using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderControlPanel.ViewModels.PartnerCenter.Order
{
    [Export(typeof(OrderLineItemViewModel))]
    public class OrderLineItemViewModel : Screen
    {
        private LineItem orderLineItem;

        [ImportingConstructor]
        public OrderLineItemViewModel(LineItem lineItem)
        {
            orderLineItem = lineItem;
        }

        public int LineItemNumber
        {
            get
            {
                return orderLineItem.LineItemNumber;
            }
        }

        public int Quantity
        {
            get
            {
                return orderLineItem.Quantity;
            }
        }

        public string Subscription
        {
            get
            {
                return orderLineItem.ResultingSubscriptionUri.Substring(orderLineItem.ResultingSubscriptionUri.LastIndexOf(@"subscriptions/") + 14);
            }
        }

        public string Offer
        {
            get
            {
                //return CSPManager.GetOfferFriendlyName(orderLineItem.OfferUri);
                return orderLineItem.OfferUri;
            }
        }
    }
}
