﻿using Caliburn.Micro;
using Microsoft.Samples.CloudSolutionProviderManagement.PartnerCenter.DataModel;
using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Samples.CloudSolutionProviderControlPanel.ViewModels.PartnerCenter.Profile
{
    [Export(typeof(ProfileViewModel))]
    public class ProfileViewModel : Screen
    {
        private readonly IWindowManager windowManager;
        private readonly IEventAggregator eventAggregator;
        private ProfileItem profileItem = null;

        [ImportingConstructor]
        public ProfileViewModel(IWindowManager winMgr, IEventAggregator evt, ProfileItem item)
        {
            windowManager = winMgr;
            eventAggregator= evt;
            profileItem = item;
        }

        public string CompanyName
        {
            get
            {
                return profileItem.CompanyName;
            }
        }

        public string Email
        {
            get
            {
                return profileItem.Email;
            }
        }

        public string FirstName
        {
            get
            {
                return profileItem.DefaultAddress.FirstName;
            }
        }

        public string LastName
        {
            get
            {
                return profileItem.DefaultAddress.LastName;
            }
        }

        public string PhoneNumber
        {
            get
            {
                return profileItem.DefaultAddress.PhoneNumber;
            }
        }

        public string DefaultLanguage
        {
            get
            {
                return profileItem.Language;
            }
        }

        public string CustomerId
        {
            get
            {
                return profileItem.CustomerId;
            }
        }

        public string AddressLine1
        {
            get
            {
                return profileItem.DefaultAddress.AddressLine1;
            }
        }

        public string AddressLine2
        {
            get
            {
                return profileItem.DefaultAddress.AddressLine2;
            }
        }

        public string AddressLine3
        {
            get
            {
                return profileItem.DefaultAddress.AddressLine3;
            }
        }

        public string City
        {
            get
            {
                return profileItem.DefaultAddress.City;
            }
        }

        public string Region
        {
            get
            {
                return profileItem.DefaultAddress.Region;
            }
        }

        public string PostalCode
        {
            get
            {
                return profileItem.DefaultAddress.PostalCode;
            }
        }

        public string Country
        {
            get
            {
                return profileItem.DefaultAddress.Country;
            }
        }

        public void EditProfile()
        {
            windowManager.ShowDialog(new EditProfileViewModel(eventAggregator, profileItem));
        }
    }
}
